<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" label-width="100px" :inline="true">
            <el-form-item label="凭证类型编号" prop="certificateId">
              <el-select v-model="queryParams.certificateId" clearable placeholder="凭证大类">
                <template #header>
                  <el-input v-model="likeCostName" placeholder="可根据场景编码或名称模糊查询" @input="filterByCostIdName"></el-input>
                </template>
                <el-option
                  v-for="option in filteredCostList"
                  :key="option.certificateId"
                  :label="option.certificateId + '-' + option.certificateName"
                  :value="option.certificateId"
                >
                </el-option>
              </el-select>
            </el-form-item>
            <el-row>
              <el-form-item>
                <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
                <el-button icon="Refresh" @click="resetQuery">重置</el-button>
              </el-form-item>
            </el-row>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button v-hasPermi="['bfs:certificateTypeDef:add']" type="primary" plain icon="Plus" @click="handleAdd">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button v-hasPermi="['bfs:certificateTypeDef:export']" type="warning" plain icon="Download" @click="handleExport">导出</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button v-hasPermi="['bfs:finItemDef:import']" type="danger" plain icon="Upload" @click="handleImport">导入</el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @query-table="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" :data="certificateTypeDefList" @selection-change="handleSelectionChange">
        <el-table-column label="凭证类型编号" align="center" prop="certificateId" />
        <el-table-column label="凭证类型名称" align="center" prop="certificateName" />
        <el-table-column label="说明" align="center" prop="remark" v-if="false" />
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button v-hasPermi="['bfs:certificateTypeDef:edit']" link type="primary" icon="Edit" @click="handleUpdate(scope.row)"></el-button>
            </el-tooltip>
            <el-tooltip content="查看费用类型" placement="top">
              <el-button
                v-hasPermi="['bfs:certificateTypeDef:detail']"
                link
                type="primary"
                icon="ChatLineRound"
                @click="handleCostType(scope.row)"
              ></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" :total="total" @pagination="getList" />
    </el-card>
    <!-- 添加或修改凭证类型定义对话框 -->
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="500px" append-to-body>
      <el-form ref="certificateTypeDefFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="凭证类型编号" prop="certificateId">
          <el-input v-model="form.certificateId" placeholder="请输入凭证类型编号" />
        </el-form-item>
        <el-form-item label="凭证类型名称" prop="certificateName">
          <el-input v-model="form.certificateName" placeholder="请输入凭证类型名称" />
        </el-form-item>
        <el-form-item label="说明" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>

    <el-dialog v-model="upload.open" :title="upload.title" width="400px" append-to-body>
      <el-upload
        ref="uploadRef"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <el-icon class="el-icon--upload">
          <i-ep-upload-filled />
        </el-icon>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <template #tip>
          <div class="text-center el-upload__tip">
            <span>仅允许导入xls、xlsx格式文件。</span>
            <el-link type="primary" :underline="false" style="font-size: 12px; vertical-align: baseline" @click="importTemplate">下载模板</el-link>
          </div>
        </template>
      </el-upload>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitFileForm">确 定</el-button>
          <el-button @click="upload.open = false">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="CertificateTypeDef" lang="ts">
import {
  listCertificateTypeDef,
  getCertificateTypeDef,
  delCertificateTypeDef,
  addCertificateTypeDef,
  updateCertificateTypeDef
} from '@/api/bfs/fiCertificateType/index';
import { CertificateTypeDefVO, CertificateTypeDefQuery, CertificateTypeDefForm } from '@/api/bfs/fiCertificateType/certificateType';
import {globalHeaders, globalUploadHeaders} from '@/utils/request';
import {getCacheList} from "@/api/bfs/busnessQury/costBalance";

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const certificateTypeDefList = ref<CertificateTypeDefVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const certificateTypeDefFormRef = ref<ElFormInstance>();
const certificateId = ref('');
const likeCostName = ref('');
const filteredCostList = ref([]);
const selectCostList = ref([]);

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const costTypeDialog = reactive<DialogOption>({
  visible: false
});

const uploadRef = ref<ElUploadInstance>();

/*** 用户导入参数 */
const upload = reactive<ImportOption>({
  // 是否显示弹出层（用户导入）
  open: false,
  // 弹出层标题（用户导入）
  title: '',
  // 是否禁用上传
  isUploading: false,
  // 是否更新已经存在的用户数据
  updateSupport: 0,
  // 设置上传的请求头部
  headers: globalUploadHeaders(),
  // 上传的地址
  url: import.meta.env.VITE_APP_BASE_API + '/bfs/certificateTypeDef/importData'
});

const initFormData: CertificateTypeDefForm = {
  id: undefined,
  certificateId: undefined,
  certificateName: undefined,
  detailIndexId: undefined,
  detailIndexName: undefined,
  acquisitionType: undefined,
  remark: undefined
};
const data = reactive<PageData<CertificateTypeDefForm, CertificateTypeDefQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    certificateId: undefined,
    certificateName: undefined,
    detailIndexId: undefined,
    detailIndexName: undefined,
    acquisitionType: undefined,
    params: {}
  },
  rules: {
    certificateId: [{ required: true, message: '凭证类型编号不能为空', trigger: 'blur' }],
    certificateName: [{ required: true, message: '凭证类型名称不能为空', trigger: 'blur' }],
    remark: [{ required: true, message: '说明不能为空', trigger: 'blur' }]
  }
});
const { queryParams, form, rules } = toRefs(data);
/** 查询凭证类型定义列表 */
const getList = async () => {
  loading.value = true;
  const res = await listCertificateTypeDef(queryParams.value);
  certificateTypeDefList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  certificateTypeDefFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: CertificateTypeDefVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加凭证类型定义';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: CertificateTypeDefVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getCertificateTypeDef(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改凭证类型定义';
};

/** 提交按钮 */
const submitForm = () => {
  certificateTypeDefFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateCertificateTypeDef(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addCertificateTypeDef(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: CertificateTypeDefVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除凭证类型定义编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delCertificateTypeDef(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'bfs/certificateTypeDef/export',
    {
      ...queryParams.value
    },
    `凭证规则明细_${new Date().getTime()}.xlsx`
  );
};

/**文件上传中处理 */
const handleFileUploadProgress = () => {
  upload.isUploading = true;
};
/** 文件上传成功处理 */
const handleFileSuccess = (response: any, file: UploadFile) => {
  upload.open = false;
  upload.isUploading = false;
  uploadRef.value?.handleRemove(file);
  ElMessageBox.alert("<div style='overflow: auto;overflow-x: hidden;max-height: 70vh;padding: 10px 20px 0;'>" + response.msg + '</div>', '导入结果', {
    dangerouslyUseHTMLString: true
  });
  getList();
};

/** 下载模板操作 */
const importTemplate = () => {
  proxy?.download('bfs/certificateTypeDef/importTemplate', {}, `凭证规则导入模版_${new Date().getTime()}.xlsx`);
};

/** 导入按钮操作 */
const handleImport = () => {
  upload.title = '导入';
  upload.open = true;
};

/** 提交上传文件 */
const submitFileForm = () => {
  uploadRef.value?.submit();
};

/** 查看费用类型 */
const handleCostType = (row: CertificateTypeDefVO) => {
  // proxy.$tab.closePage(proxy.$route);
  proxy.$router.push({
    path: `/bfs/config/fi-certificate-type/costTypeDef`,
    query: {
      certificateId: row.certificateId,
      certificateName: row.certificateName
    }
  });
};
const getCache = async () => {
  const res = await getCacheList();
  selectCostList.value = res.data.certificateList1;
  filteredCostList.value = selectCostList.value;
};
const filterByCostIdName = () => {
  if (likeCostName.value) {
    filteredCostList.value = selectCostList.value.filter((item) => {
      return item.certificateId.includes(likeCostName.value) || item.certificateName.includes(likeCostName.value);
    });
  } else {
    filteredCostList.value = selectCostList.value;
  }
};

onMounted(() => {
  getCache();
  getList();
});
</script>
